    PROGRAM

    MAP
      GetLocalIP,STRING
      MODULE('WinAPI')
        WSAStartup(UNSIGNED,LONG),SIGNED,PASCAL,NAME('WSASTARTUP'),DLL(dll_mode)
        WSAGetLastError(),SIGNED,RAW,PASCAL,NAME('WSAGETLASTERROR'),DLL(dll_mode),PROC
        WSACleanup,SIGNED,PASCAL,NAME('WSACLEANUP'),DLL(dll_mode)
        ssocket(SIGNED,SIGNED,SIGNED),UNSIGNED,PASCAL,NAME('SOCKET'),DLL(dll_mode)
        connect(UNSIGNED, *SOCKADDR_IN, SHORT),SHORT,RAW,PASCAL,NAME('CONNECT'),DLL(dll_mode)
        getsockname(UNSIGNED, *SOCKADDR_IN, *SHORT),SHORT,RAW,PASCAL,NAME('GETSOCKNAME'),DLL(dll_mode)
        htons(USHORT),USHORT,PASCAL,NAME('HTONS'),DLL(dll_mode)
        inet_addr(*CSTRING),ULONG,PASCAL,RAW,NAME('INET_ADDR'),DLL(dll_mode)
        closesocket(UNSIGNED),SIGNED,PASCAL,NAME('CLOSESOCKET'),DLL(dll_mode),PROC
        inet_ntoa(ULONG),CSTRING,PASCAL,RAW,NAME('INET_NTOA'),DLL(dll_mode)
      END
      CheckErr(LONG),STRING
    END

SOCKET_ERROR            EQUATE(-1)

wsReturnCode            SHORT

s32_Version1_1          EQUATE(0000000100000001b) !WS version 1.1
s32_Version2_0          EQUATE(0000001000000010b) !WS version 2.0

WSAData                 GROUP,TYPE
wVersion                  SHORT
wHighVersion              SHORT
szDescription             CSTRING(257)
szSystemStatus            CSTRING(129)
iMaxSockets               USHORT
iMaxUdpDg                 USHORT
lpVendorInfo              CSTRING(257)
                        END
WsData                  LIKE(WSADATA),PRE(WSD)


hSocket            UNSIGNED

AF_INET                 EQUATE(2)
SOCK_STREAM             EQUATE(1)
SOCK_DGRAM              EQUATE(2)
IPPROTO_IP              EQUATE(0)
INVALID_SOCKET          EQUATE(-1)

in_addr                 GROUP,TYPE
S_un                      GROUP
S_addr                      ULONG
S_un_b                      GROUP,OVER(S_addr)
s_b1                          BYTE
s_b2                          BYTE
s_b3                          BYTE
s_b4                          BYTE
                            END
S_un_w                      GROUP,OVER(S_addr)
s_w1                          USHORT
s_w2                          USHORT
                            END
                          END
                        END



sockaddr_in             GROUP,TYPE
sin_family                SHORT
sin_port                  USHORT
sin_addr                  LIKE(in_addr),PRE(sin)
sin_zero                  CSTRING(8)
                        END

stRmtAddr               LIKE(sockaddr_in),PRE(RMT)
stLclAddr               LIKE(sockaddr_in),PRE(LCL)
nAddrSize               SHORT


DummyIpAddr             CSTRING('208.30.36.226<0>')
nRet                    SHORT

sockaddr                GROUP,TYPE
sin_port                  USHORT
sin_zero                  CSTRING(14)
                        END
    CODE

    MESSAGE(GetLocalIP())

!---------------------------
GetLocalIP      PROCEDURE
!---------------------------

    CODE

    wsReturnCode = WSAStartup(s32_Version2_0, ADDRESS(wsdata)) !store winsock vars in wsData

    IF wsReturnCode
      RETURN('---1:' & CheckErr(WSAGetLastError()))
    END

    hSocket = ssocket(AF_INET, SOCK_DGRAM, IPPROTO_IP)

    IF hSocket = INVALID_SOCKET
      WSACleanup()
      RETURN('---2:' & CheckErr(WSAGetLastError()))
    END

    RMT:sin_family = AF_INET
    RMT:sin_port = htons(80)
    RMT:S_addr = inet_addr(DummyIpAddr)
    nAddrSize = SIZE(stRmtAddr)

    nRet = connect(hSocket, stRmtAddr, nAddrSize)

    IF nRet <> SOCKET_ERROR
      LCL:S_addr = 0
      RetVal# = getsockname(hSocket, stLclAddr, nAddrSize)

      IF RetVal# = SOCKET_ERROR
        closesocket(hSocket)
        WSACleanup()
        RETURN('---3:' & CheckErr(WSAGetLastError()))
      END
    ELSE
      closesocket(hSocket)
      WSACleanup()
      RETURN('---4:' & CheckErr(WSAGetLastError()))
    END

    closesocket(hSocket)

    IF WSACleanup() = SOCKET_ERROR
      !MESSAGE('---5:' & CheckErr(WSAGetLastError()))
    END

    RETURN(inet_ntoa(LCL:S_addr))


!-------------------------------------------------------------------------------------------------
CheckErr             PROCEDURE  (ErrCode)             ! Declare Procedure
!-------------------------------------------------------------------------------------------------

WSABASEERR              EQUATE(10000)

WSAEINTR                    EQUATE(WSABASEERR+4)
WSAEBADF                    EQUATE(WSABASEERR+9)
WSAEACCES                   EQUATE(WSABASEERR+13)
WSAEFAULT                   EQUATE(WSABASEERR+14)
WSAEINVAL                   EQUATE(WSABASEERR+22)
WSAEMFILE                   EQUATE(WSABASEERR+24)
MAXGETHOSTSTRUCT            EQUATE(1024)

WSAEWOULDBLOCK              EQUATE(WSABASEERR+35)
WSAEINPROGRESS              EQUATE(WSABASEERR+36)
WSAEALREADY                 EQUATE(WSABASEERR+37)
WSAENOTSOCK                 EQUATE(WSABASEERR+38)
WSAEDESTADDRREQ             EQUATE(WSABASEERR+39)
WSAEMSGSIZE                 EQUATE(WSABASEERR+40)
WSAEPROTOTYPE               EQUATE(WSABASEERR+41)
WSAENOPROTOOPT              EQUATE(WSABASEERR+42)
WSAEPROTONOSUPPORT          EQUATE(WSABASEERR+43)
WSAESOCKTNOSUPPORT          EQUATE(WSABASEERR+44)
WSAEOPNOTSUPP               EQUATE(WSABASEERR+45)
WSAEPFNOSUPPORT             EQUATE(WSABASEERR+46)
WSAEAFNOSUPPORT             EQUATE(WSABASEERR+47)
WSAEADDRINUSE               EQUATE(WSABASEERR+48)
WSAEADDRNOTAVAIL            EQUATE(WSABASEERR+49)
WSAENETDOWN                 EQUATE(WSABASEERR+50)
WSAENETUNREACH              EQUATE(WSABASEERR+51)
WSAENETRESET                EQUATE(WSABASEERR+52)
WSAECONNABORTED             EQUATE(WSABASEERR+53)
WSAECONNRESET               EQUATE(WSABASEERR+54)
WSAENOBUFS                  EQUATE(WSABASEERR+55)
WSAEISCONN                  EQUATE(WSABASEERR+56)
WSAENOTCONN                 EQUATE(WSABASEERR+57)
WSAESHUTDOWN                EQUATE(WSABASEERR+58)
WSAETOOMANYREFS             EQUATE(WSABASEERR+59)
WSAETIMEDOUT                EQUATE(WSABASEERR+60)
WSAECONNREFUSED             EQUATE(WSABASEERR+61)
WSAELOOP                    EQUATE(WSABASEERR+62)
WSAENAMETOOLONG             EQUATE(WSABASEERR+63)
WSAEHOSTDOWN                EQUATE(WSABASEERR+64)
WSAEHOSTUNREACH             EQUATE(WSABASEERR+65)
WSAENOTEMPTY                EQUATE(WSABASEERR+66)
WSAEPROCLIM                 EQUATE(WSABASEERR+67)
WSAEUSERS                   EQUATE(WSABASEERR+68)
WSAEDQUOT                   EQUATE(WSABASEERR+69)
WSAESTALE                   EQUATE(WSABASEERR+70)
WSAEREMOTE                  EQUATE(WSABASEERR+71)

WSASYSNOTREADY              EQUATE(WSABASEERR+91)
WSAVERNOTSUPPORTED          EQUATE(WSABASEERR+92)
WSANOTINITIALISED           EQUATE(WSABASEERR+93)
WSANOSOCKETS                EQUATE(WSABASEERR+94)

WSAHOST_NOT_FOUND           EQUATE(WSABASEERR+1001)
HOST_NOT_FOUND              EQUATE(WSAHOST_NOT_FOUND)
WSATRY_AGAIN                EQUATE(WSABASEERR+1002)
TRY_AGAIN                   EQUATE(WSATRY_AGAIN)
WSANO_RECOVERY              EQUATE(WSABASEERR+1003)
NO_RECOVERY                 EQUATE(WSANO_RECOVERY)
WSANO_DATA                  EQUATE(WSABASEERR+1004)
NO_DATA                     EQUATE(WSANO_DATA)

WSANO_ADDRESS               EQUATE(WSANO_DATA)
NO_ADDRESS                  EQUATE(WSANO_ADDRESS)
RtrnStr              STRING(100)
    CODE
    CASE ErrCode
    OF WSAVERNOTSUPPORTED
      RtrnStr = 'Version of Winsock Not Supported'
    OF WSASYSNOTREADY
      RtrnStr = 'Winsock Not Present or not responding'
    OF WSAEINVAL
      RtrnStr = 'App Version Not supported by DLL'
    OF WSAHOST_NOT_FOUND
      RtrnStr = 'Authoritative: Host Not Found'
    OF WSATRY_AGAIN
      RtrnStr = 'Non-Authoritative: host not found or Server Failure'
    OF WSANO_RECOVERY
      RtrnStr = 'Non-Recoverable: refused or not implemented'
    OF WSANO_DATA
      RtrnStr = 'Valid Name, no data record for that type'
    OF WSAEINTR
      RtrnStr = 'Blocking call canceled'
    OF WSAESOCKTNOSUPPORT
      RtrnStr = 'Specified Protocol is not supported'
    OF WSAENOTSOCK
      RtrnStr = 'Socket Type not supported for Address Family'
    OF WSAEWOULDBLOCK
      RtrnStr = 'Socket marked as non-blocking and SO_LINGER set not 0'
    OF WSAEADDRINUSE
      RtrnStr = 'Address already in use'
    OF WSAECONNABORTED
      RtrnStr = 'Connection Aborted'
    OF WSAECONNRESET
      RtrnStr = 'Connection Reset'
    OF WSAEISCONN
      RtrnStr = 'The socket is already connected.'
    OF WSAENOTCONN
      RtrnStr = 'Not Connected'
    OF WSAESHUTDOWN
      RtrnStr = 'The network subsystem has failed.'
    OF WSAETIMEDOUT
      RtrnStr = 'Connection Timed Out'
    OF WSAECONNREFUSED
      RtrnStr = 'Connection Refused'
    OF WSAEHOSTDOWN
      RtrnStr = 'Host Down'
    OF WSAEHOSTUNREACH
      RtrnStr = 'Host Unreachable'
    OF WSAEADDRNOTAVAIL
      RtrnStr = 'Address Not Available'
    OF WSANOTINITIALISED
      RtrnStr = 'Invalid Socket returned from "socket()"|WSA Startup not initialised|A successful WSAStartup call must occur before using this function.'
    OF WSAENETDOWN
      RtrnStr = 'Invalid Socket returned from "socket()"|Network Sub-System Failed|The network subsystem or the associated service|provider has failed.'
    OF WSAEAFNOSUPPORT
      RtrnStr = 'Invalid Socket returned from "socket()"| The specified address family is not supported.'
    OF WSAEINPROGRESS
      RtrnStr = 'Invalid Socket returned from "socket()"|A blocking Windows Sockets 1.1 call is in progress,|or the service provider is still|processing a callback function.'
    OF WSAEMFILE
      RtrnStr = 'Invalid Socket returned from "socket()"|No more socket descriptors are available.'
    OF WSAENOBUFS
      RtrnStr = 'Invalid Socket returned from "socket()"|No buffer space is available.|The socket cannot be created.'
    OF WSAEPROTONOSUPPORT
      RtrnStr = 'Invalid Socket returned from "socket()"| The specified protocol is not supported.'
    OF WSAEPROTOTYPE
      RtrnStr = 'Invalid Socket returned from "socket()"|The specified socket protocol is the wrong type|for this socket and not supported|in this address family..'
    ELSE
     RtrnStr = 'Unknown Error, Error = ' & ErrCode
    END
    RETURN(RtrnStr)
